%define gcj_support 1

Name:		jessie
Version:	1.0.1
Release:	7
Epoch:		0
Summary:	A free implementation of the Java Secure Sockets Extension

Group:		Security/Cryptography
License:	GPL
URL:		http://www.nongnu.org/jessie/
Source0:	%{name}-%{version}.tar.gz
# workaround for http://gcc.gnu.org/bugzilla/show_bug.cgi?id=19870
Patch0:		jessie-1.0.0-gcj-workaround.patch
Patch1:		jessie-1.0.0-dont-print-name.patch
Patch2:		jessie-1.0.1-ssl-socket.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

Requires:	%{_bindir}/perl
Requires:	gnu-crypto >= 0:2.1.0
Requires:	java-sasl
Requires:	jce
BuildRequires:	gnu-crypto >= 0:2.1, jpackage-utils > 0:1.5
BuildRequires:  java-devel >= 0:1.4
Requires:	java >= 0:1.4
%if %{gcj_support}
Requires:	libgcj >= 4.0.0-0.42
Requires(post): jpackage-utils >= 0:1.6.3-1jpp_1rh
Requires(postun): jpackage-utils >= 0:1.6.3-1jpp_1rh
%endif

%description
JESSIE is a cleanroom implementation of the Java Secure Sockets
Extension, the JSSE, which aims for compliance and compatibility with
the JSSE as it exists in Java 2 Standard Edition, version 1.4.

%prep
%setup -q
%patch0 -p0
%patch1 -p0
%patch2 -p0

%build
export CLASSPATH=%{_javadir}/gnu-crypto.jar:.:
%configure --enable-provider-only
make

%if %{gcj_support}
gcj-dbtool -n jsse-%{version}.jar.db 64
gcj -shared $RPM_OPT_FLAGS -fPIC -findirect-dispatch -fjni -Wl,-Bsymbolic \
  lib/org-metastatic-jessie.jar -o jsse-%{version}.jar.so
gcj-dbtool -f jsse-%{version}.jar.db lib/org-metastatic-jessie.jar \
  %{_libdir}/gcj/%{name}/jsse-%{version}.jar.so
%endif

%install
rm -rf $RPM_BUILD_ROOT

install -dm 755 $RPM_BUILD_ROOT%{_javadir}
install -pm 644 lib/org-metastatic-jessie.jar \
  $RPM_BUILD_ROOT%{_javadir}/jsse-%{version}.jar
ln -s jsse-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/jsse.jar

%if %{gcj_support}
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d
touch $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d/2000-org.metastatic.jessie.provider.Jessie

install -dm 755 $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed
ln -s %{_javadir}/jsse-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed/jsse.jar

mkdir -p $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
install -m755 jsse-%{version}.jar.so $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
install -m644 jsse-%{version}.jar.db $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-security-providers ]
then
  %{_bindir}/rebuild-security-providers
fi

if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-security-providers ]
then
  %{_bindir}/rebuild-security-providers
fi

if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog COPYING README THANKS
%{_javadir}/jsse*.jar
%if %{gcj_support}
%{_javadir}/gcj-endorsed/jsse*.jar
%{_sysconfdir}/java/security/security.d/2000-org.metastatic.jessie.provider.Jessie
%attr(-,root,root) %{_libdir}/gcj/%{name}
%endif

%changelog
* Sun Oct 01 2006 Jesse Keating <jkeating@redhat.com> - 0:1.0.1-7
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Mon Sep 21 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.1-6
- Uncomment 1.4 methods from SSLSocket.java. (206278)

* Tue Jul 25 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.1-4
- Bump release number.

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 0:1.0.1-3.1
- rebuild

* Wed Mar  1 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.1-3
- Bump release number.

* Wed Mar  1 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.1-2
- Add : to end of CLASSPATH.
- Natively compile Jessie.

* Thu Feb  2 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.1-1
- Revert back to 1.0.1 sources.

* Thu Feb  2 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.1-2
- Revert to 1.0.0 sources.

* Thu Feb  2 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.1-1
- Import Jessie 1.0.1.
- Require java-sasl instead of gnu-crypto-sasl-jdk1.4 and jce instead
  of gnu-crypto-jce-jdk1.4 >= 0:2.0.1-1jpp_2fc.

* Thu Dec 22 2005 Jesse Keating <fitzsim@redhat.com> 0:1.0.0-11
- Bump for gcc/gcj

* Thu Dec  8 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.0.0-10
- Bump release number.

* Wed Nov 16 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.0-9
- Call rebuild-security-providers conditionally on its existence.

* Thu May 26 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.0-8
- Require libgcj.
- Separate post and postun requirement lines.
- Specify gnu-crypto jar directly.

* Mon May 16 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.0-7
- Require jpackage-utils for post and postun.
- Run rebuild-security-providers with full path.

* Mon Apr 25 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.0-6
- Build the provider only.

* Fri Apr 15 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.0-5
- Require gnu-crypto.

* Wed Apr 13 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.0-4
- Add gcj endorsed dir support.

* Thu Mar 17 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.0-3
- Don't install security.d file.

* Thu Mar 10 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.0-2
- Comment out extdirs support.
- Install provider file.

* Sat Mar  5 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.0.0-1
- Initial build.
